#ifndef FINDRESULTMODEL_H
#define FINDRESULTMODEL_H

#include <QAbstractItemModel>
#include <QModelIndex>
#include <QVariant>

class FindResultItem;
class TreeItem;

class FindResultModel : public QAbstractItemModel
{
    Q_OBJECT

public:
    FindResultModel( QObject *parent = 0);
    ~FindResultModel();
	void clear();

    QVariant data(const QModelIndex &index, int role) const;
    QVariant headerData(int section, Qt::Orientation orientation,
                        int role = Qt::DisplayRole) const;

	QModelIndex index (FindResultItem *fri);
    QModelIndex index(int row, int column,
                      const QModelIndex &parent = QModelIndex()) const;
    QModelIndex parent(const QModelIndex &index) const;

    int rowCount(const QModelIndex &parent = QModelIndex()) const;
    int columnCount(const QModelIndex &parent = QModelIndex()) const;

    Qt::ItemFlags flags(const QModelIndex &index) const;
    bool setData(const QModelIndex &index, const QVariant &value,
                 int role = Qt::EditRole);
    bool setHeaderData(int section, Qt::Orientation orientation,
                       const QVariant &value, int role = Qt::EditRole);

    bool insertColumns(int position, int columns,
                       const QModelIndex &parent = QModelIndex());
    bool removeColumns(int position, int columns,
                       const QModelIndex &parent = QModelIndex());
    bool insertRows(int position, int rows,
                    const QModelIndex &parent = QModelIndex());
    bool removeRows(int position, int rows,
                    const QModelIndex &parent = QModelIndex());

    FindResultItem *getItem(const QModelIndex &index) const;

	void addItem (TreeItem *ti);
	void addItem (const QString &s);
	void addSubItem (TreeItem *parent,const QString &s, TreeItem *ti, int index);

private:

    FindResultItem *rootItem;
};

#endif
